-------------------------------------------------------
--! @file parity44.vhd
--! @brief 4-bit parity checker
--! @author Edson S. Gomi (gomi@usp.br)
--! @date 2018-10-05
-------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;

entity parity4 is
  port (
    I :         in std_logic_vector (3 downto 0);
    ODD :       out std_logic;
    EVEN :      out std_logic
    );
end entity parity4;

architecture parity4_arch of parity4 is

  signal p0,p1,p2 : std_logic;
  
begin
  p0 <= I(0) xor I(1);
  p1 <= I(2) xor I(3);
  p2 <= p0 xor p1;
  ODD <= p2;
  EVEN <= not(p2);
end architecture parity4_arch;
