-------------------------------------------------------
--! @file mux.vhd
--! @brief 4-to-1 multiplexer
--! @author Edson S. Gomi (gomi@usp.br)
--! @date 2020-04-28
-------------------------------------------------------

entity mux is
  port (
    I : in bit_vector (3 downto 0);
    SEL : in bit_vector (1 downto 0);
    Y : out bit
    );
end entity mux;

architecture with_select of mux is
begin
  with SEL select
    Y <= I(0) when "00",
         I(1) when "01",
         I(2) when "10",
         I(3) when "11",
          '0' when others;
end architecture with_select;

architecture when_else of mux is
begin
  Y <= I(0) when SEL = "00" else
       I(1) when SEL = "01" else
       I(2) when SEL = "10" else
       I(3) when SEL = "11" else
       '0';
end architecture when_else;

