-------------------------------------------------------
--! @file sub4.vhd
--! @brief 4-bit subtractor
--! @author Edson S. Gomi (gomi@usp.br)
--! @date 2018-10-07
-------------------------------------------------------


entity sub4 is
  port (
    BIN : in bit;
    X : in bit_vector (3 downto 0);
    Y : in bit_vector (3 downto 0);
    DIFF : out bit_vector (3 downto 0);
    BOUT : out bit
    );
end entity sub4;

architecture sub4_arch of sub4 is

component adder4 is
  port (
    cin : in bit;
    x : in bit_vector (3 downto 0);
    y : in bit_vector (3 downto 0);
    sum : out bit_vector (3 downto 0);
    cout : out bit
    );
end component adder4;

component twocomp4 is
  port (
    A : in bit_vector (3 downto 0);
    A2COMP : out bit_vector (3 downto 0)
    );
end component twocomp4;

signal Y2COMP : bit_vector (3 downto 0);
  
begin
  U2COMP : component twocomp4 port map (Y,Y2COMP);  
  UADD : component adder4 port map (BIN,X,Y2COMP,DIFF,BOUT);
end architecture sub4_arch;
